<cfparam name="form.location" type="string" default="">

<cfset variables.sVars = StructNew()>
<cfset variables.sVars.cUrlContents = "">
<cfset variables.sVars.xmlDoc = "">
<cfset variables.sVars.cRowClass = "">

<html>

<head>
<title>Find the weather.com Location ID of a place</title>
<style type="text/css">
body {
	font-family:Tahoma;
	font-size:70%;
	text-align:center;
}
.locationResults {
	border:1px solid #CAD3A4;
	font-family:Tahoma;
	font-size:100%;
}
.locationResults .header {
	background-color:#BED273;
	font-weight:bold;
	padding:10px 5px;
}
.locationResults .data0 {
	background-color:#EFF5D7;
	padding:5px;
}
.locationResults .data1 {
	background-color:#FFF;
	padding:5px;
}
</style>
</head>

<body>
	<h3>Weather.com "Location ID" finder:</h3>
	<cfoutput>
	<form name="frmLocation" method="post" action="#cgi.SCRIPT_NAME#">
		<input type="textbox" name="location" value="#form.location#" size="50">
		&nbsp;
		<input type="submit" value="Submit">
	</form>
	</cfoutput>
	
	<cfif Len(form.location)>
		<cfhttp method="GET" 
			url="http://xoap.weather.com/search/search?where=#form.location#" 
			resolveurl="false"
			timeout="30">
		</cfhttp>
		<cfif cfhttp.Statuscode IS "200 OK">
			<cfset variables.sVars.cUrlContents = cfhttp.FileContent>
			<cfset variables.sVars.xmlDoc = XMLParse(variables.sVars.cUrlContents)>
			<cfset variables.sVars.searchResults = XmlSearch(variables.sVars.xmlDoc, "/search")>
			<cfset variables.sVars.searchResults = variables.sVars.searchResults[1]>
			<cfset variables.sVars.iResults = StructCount(variables.sVars.searchResults)>
			
			<cfif variables.sVars.iResults GT 0>
				<table border="0" cellpadding="0" cellspacing="0" class="locationResults" align="center">
					<tr>
						<td class="header">&nbsp;</td>
						<td class="header">Description</td>
						<td class="header">Location ID</td>
					</tr>
					<cfoutput>
						<cfloop from="1" to="#StructCount(variables.sVars.searchResults)#" index="i">
							<cfset variables.sVars.cRowClass = i Mod 2>
							<tr>
								<td class="data#variables.sVars.cRowClass#">#i#.</td>
								<td class="data#variables.sVars.cRowClass#">#variables.sVars.searchResults.loc[i].XmlText#</td>
								<td class="data#variables.sVars.cRowClass#">#variables.sVars.searchResults.loc[i].XmlAttributes.id#</td>
							</tr>
						</cfloop>
					</cfoutput>
				</table>
			<cfelse>
				<span style="color:red">Sorry, no results under that search!</span>
			</cfif>
		<cfelse>
			There was a problem connecting!
			<cfabort>
		</cfif>
	</cfif>
</body>

</html>