<style type="text/css">
.currentWeather {
	background-color:#EFF5D7;
	color:#3A5029;
	font-family:Tahoma;
	font-size:70%;
	border:1px solid #CAD3A4;
	width:250px;
}
.currentWeather table {
	font-size:100%;
	color:#3A5029;
}
.currentWeather .location {
	background-color:#BED273;
	padding:5px 10px;
	font-weight:bold;
	text-align:center;
}
.currentWeather .icon {
	text-align:center;
}
.currentWeather .temperature {
	font-size:280%;
	padding-left:25px;
	text-align:center;
}
.currentWeather .description {
	font-weight:bold;
}
.currentWeather .feelslike {
	font-weight:bold;
	padding-left:25px;
}
.currentWeather .lastupdate {
	padding:10px;
}
</style>
	
<script language="javascript">
// Correctly handle PNG transparency in Win IE 5.5 or higher.
// http://homepage.ntlworld.com/bobosola
function correctPNG() {
	for (var i=0; i<document.images.length; i++) {
		var img = document.images[i]
		var imgName = img.src.toUpperCase()
		if (imgName.substring(imgName.length-3, imgName.length) == "PNG") {
			var imgID = (img.id) ? "id='" + img.id + "' " : "";
			var imgClass = (img.className) ? "class='" + img.className + "' " : "";
			var imgTitle = (img.title) ? "title='" + img.title + "' " : "title='" + img.alt + "' ";
			var imgStyle = "display:inline-block;" + img.style.cssText;
			if (img.align == "left") imgStyle = "float:left;" + imgStyle;
			if (img.align == "right") imgStyle = "float:right;" + imgStyle;
			if (img.parentElement.href) imgStyle = "cursor:hand;" + imgStyle; 
			var strNewHTML = "<span " + imgID + imgClass + imgTitle
				+ " style=\"" + "width:" + img.width + "px; height:" + img.height + "px;" + imgStyle + ";"
				+ "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
				+ "(src=\'" + img.src + "\', sizingMethod='scale');\"></span>";
			img.outerHTML = strNewHTML;
			i = i-1;
		}
	}
}
window.attachEvent("onload", correctPNG);
</script>
	
<cf_weather locationCode="GRXX0004" partnerID="xxxxxxxxxx" licenseKey="xxxxxxxxxxxxxxxx" unit="s">
<cfoutput>
	<table border="0" cellpadding="0" cellspacing="0" class="currentWeather">
		<tr>
			<td class="location">#sWeather.sLocation.city#</td>
		</tr>
		<tr>
			<td align="center">
				<br />
				<table border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td class="icon"><img src="#sWeather.sParams.imageLocation & sWeather.sParams.imageSize & "x" & sWeather.sParams.imageSize & "/" & sWeather.sCurrentConditions.icon & "." & sWeather.sParams.imageType#" border="0" alt="#sWeather.sCurrentConditions.description#"></td>
						<td class="temperature">#sWeather.sCurrentConditions.temperature#&##176;#sWeather.sProperties.temperature#</td>
					</tr>
					<tr>
						<td class="description">#sWeather.sCurrentConditions.description#</td>
						<td class="feelslike">Feels like #sWeather.sCurrentConditions.feelslike#&##176;#sWeather.sProperties.temperature#</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td align="center">
				<br />
				<br />
				<table border="0" cellpadding="1" cellspacing="0">
					<tr>
						<td align="right" valign="top">UV index:</td>
						<td valign="top">#sWeather.sCurrentConditions.uvindex# #sWeather.sCurrentConditions.uvDescription#</td>
					</tr>
					<tr>
						<td align="right" valign="top">Dew Point:</td>
						<td valign="top">#sWeather.sCurrentConditions.dewpoint#&##176;#sWeather.sProperties.temperature#</td>
					</tr>
					<tr>
						<td align="right" valign="top">Humidity:</td>
						<td valign="top">#sWeather.sCurrentConditions.humidity#%</td>
					</tr>
					<tr>
						<td align="right" valign="top">Visibility:</td>
						<td valign="top">#sWeather.sCurrentConditions.visibility# #sWeather.sProperties.distance#</td>
					</tr>
					<tr>
						<td align="right" valign="top">Pressure:</td>
						<td valign="top">#sWeather.sCurrentConditions.barIndex# #sWeather.sProperties.pressure# (#sWeather.sCurrentConditions.barDescription#)</td>
					</tr>
					<tr>
						<td align="right" valign="top">Wind:</td>
						<td valign="top">From the #sWeather.sCurrentConditions.winddirection# at #sWeather.sCurrentConditions.windspeed# #sWeather.sProperties.speed#</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="lastupdate" align="center">
				<br />
				As reported at #sWeather.sCurrentConditions.station#, on 
				<cfset variables.cLastUpdate = Mid(sWeather.sCurrentConditions.lastUpdate, 1, Len(sWeather.sCurrentConditions.lastUpdate) - 10)>
				<cfset variables.cLastUpdateDate = DateFormat(variables.cLastUpdate, "full")>
				<cfset variables.cLastUpdateTime = TimeFormat(variables.cLastUpdate, "h:mm tt")>
				#variables.cLastUpdateDate# at #variables.cLastUpdateTime# 
				local time<br />
				<br />
				<a href="http://www.weather.com"><img src="#sWeather.sParams.imageLocation#logos/TWClogo_31px.png" border="0" alt="Data provided by weather.com" title="Data provided by weather.com"></a>
			</td>
		</tr>
	</table>
</cfoutput>
</cf_weather>